/*
  koi8r.c.  Produce a table of the "KOI8-R" Cyrillic character set.
  F. da Cruz, Columbia University, 1999.
*/
char *name[] = {
    "FORMS LIGHT HORIZONTAL",
    "FORMS LIGHT VERTICAL",
    "FORMS LIGHT DOWN AND RIGHT",
    "FORMS LIGHT DOWN AND LEFT",
    "FORMS LIGHT UP AND RIGHT",
    "FORMS LIGHT UP AND LEFT",
    "FORMS LIGHT VERTICAL AND RIGHT",
    "FORMS LIGHT VERTICAL AND LEFT",
    "FORMS LIGHT DOWN AND HORIZONTAL",
    "FORMS LIGHT UP AND HORIZONTAL",
    "FORMS LIGHT VERTICAL AND HORIZONTAL",
    "UPPER HALF BLOCK",
    "LOWER HALF BLOCK",
    "FULL BLOCK",
    "LEFT HALF BLOCK",
    "RIGHT HALF BLOCK",
    "LIGHT SHADE",
    "MEDIUM SHADE",
    "DARK SHADE",
    "TOP HALF INTEGRAL",
    "BLACK SMALL SQUARE",
    "BULLET OPERATOR",
    "SQUARE ROOT",
    "ALMOST EQUAL TO",
    "LESS THAN OR EQUAL TO",
    "GREATER THAN OR EQUAL TO",
    "NON-BREAKING SPACE",
    "BOTTOM HALF INTEGRAL",
    "DEGREE SIGN",
    "SUPERSCRIPT DIGIT TWO",
    "MIDDLE DOT",
    "DIVISION SIGN",
    "FORMS DOUBLE HORIZONTAL",
    "FORMS DOUBLE VERTICAL",
    "FORMS DOWN SINGLE AND RIGHT DOUBLE",
    "CYRILLIC SMALL LETTER IO",
    "FORMS DOWN DOUBLE AND RIGHT SINGLE",
    "FORMS DOUBLE DOWN AND RIGHT",
    "FORMS DOWN SINGLE AND LEFT DOUBLE",
    "FORMS DOWN DOUBLE AND LEFT SINGLE",
    "FORMS DOUBLE DOWN AND LEFT",
    "FORMS UP SINGLE AND RIGHT DOUBLE",
    "FORMS UP DOUBLE AND RIGHT SINGLE",
    "FORMS DOUBLE UP AND RIGHT",
    "FORMS UP SINGLE AND LEFT DOUBLE",
    "FORMS UP DOUBLE AND LEFT SINGLE",
    "FORMS DOUBLE UP AND LEFT",
    "FORMS VERTICAL SINGLE AND RIGHT DOUBLE",
    "FORMS VERTICAL DOUBLE AND RIGHT SINGLE",
    "FORMS DOUBLE VERTICAL AND RIGHT",
    "FORMS VERTICAL SINGLE AND LEFT DOUBLE",
    "CYRILLIC CAPITAL LETTER IO",
    "FORMS VERTICAL DOUBLE AND LEFT SINGLE",
    "FORMS DOUBLE VERTICAL AND LEFT",
    "FORMS DOWN SINGLE AND HORIZONTAL DOUBLE",
    "FORMS DOWN DOUBLE AND HORIZONTAL SINGLE",
    "FORMS DOUBLE DOWN AND HORIZONTAL",
    "FORMS UP SINGLE AND HORIZONTAL DOUBLE",
    "FORMS UP DOUBLE AND HORIZONTAL SINGLE",
    "FORMS DOUBLE UP AND HORIZONTAL",
    "FORMS VERTICAL SINGLE AND HORIZONTAL DOUBLE",
    "FORMS VERTICAL DOUBLE AND HORIZONTAL SINGLE",
    "FORMS DOUBLE VERTICAL AND HORIZONTAL",
    "COPYRIGHT SIGN",
    "CYRILLIC SMALL LETTER IU",
    "CYRILLIC SMALL LETTER A",
    "CYRILLIC SMALL LETTER BE",
    "CYRILLIC SMALL LETTER TSE",
    "CYRILLIC SMALL LETTER DE",
    "CYRILLIC SMALL LETTER IE",
    "CYRILLIC SMALL LETTER EF",
    "CYRILLIC SMALL LETTER GE",
    "CYRILLIC SMALL LETTER KHA",
    "CYRILLIC SMALL LETTER II",
    "CYRILLIC SMALL LETTER SHORT II",
    "CYRILLIC SMALL LETTER KA",
    "CYRILLIC SMALL LETTER EL",
    "CYRILLIC SMALL LETTER EM",
    "CYRILLIC SMALL LETTER EN",
    "CYRILLIC SMALL LETTER O",
    "CYRILLIC SMALL LETTER PE",
    "CYRILLIC SMALL LETTER IA",
    "CYRILLIC SMALL LETTER ER",
    "CYRILLIC SMALL LETTER ES",
    "CYRILLIC SMALL LETTER TE",
    "CYRILLIC SMALL LETTER U",
    "CYRILLIC SMALL LETTER ZHE",
    "CYRILLIC SMALL LETTER VE",
    "CYRILLIC SMALL LETTER SOFT SIGN",
    "CYRILLIC SMALL LETTER YERI",
    "CYRILLIC SMALL LETTER ZE",
    "CYRILLIC SMALL LETTER SHA",
    "CYRILLIC SMALL LETTER REVERSED E",
    "CYRILLIC SMALL LETTER SHCHA",
    "CYRILLIC SMALL LETTER CHE",
    "CYRILLIC SMALL LETTER HARD SIGN",
    "CYRILLIC CAPITAL LETTER IU",
    "CYRILLIC CAPITAL LETTER A",
    "CYRILLIC CAPITAL LETTER BE",
    "CYRILLIC CAPITAL LETTER TSE",
    "CYRILLIC CAPITAL LETTER DE",
    "CYRILLIC CAPITAL LETTER IE",
    "CYRILLIC CAPITAL LETTER EF",
    "CYRILLIC CAPITAL LETTER GE",
    "CYRILLIC CAPITAL LETTER KHA",
    "CYRILLIC CAPITAL LETTER II",
    "CYRILLIC CAPITAL LETTER SHORT II",
    "CYRILLIC CAPITAL LETTER KA",
    "CYRILLIC CAPITAL LETTER EL",
    "CYRILLIC CAPITAL LETTER EM",
    "CYRILLIC CAPITAL LETTER EN",
    "CYRILLIC CAPITAL LETTER O",
    "CYRILLIC CAPITAL LETTER PE",
    "CYRILLIC CAPITAL LETTER IA",
    "CYRILLIC CAPITAL LETTER ER",
    "CYRILLIC CAPITAL LETTER ES",
    "CYRILLIC CAPITAL LETTER TE",
    "CYRILLIC CAPITAL LETTER U",
    "CYRILLIC CAPITAL LETTER ZHE",
    "CYRILLIC CAPITAL LETTER VE",
    "CYRILLIC CAPITAL LETTER SOFT SIGN",
    "CYRILLIC CAPITAL LETTER YERI",
    "CYRILLIC CAPITAL LETTER ZE",
    "CYRILLIC CAPITAL LETTER SHA",
    "CYRILLIC CAPITAL LETTER REVERSED E",
    "CYRILLIC CAPITAL LETTER SHCHA",
    "CYRILLIC CAPITAL LETTER CHE",
    "CYRILLIC CAPITAL LETTER HARD SIGN"
};

main() {
    int i, j;
    printf("KOI8-R (RFC 1489)\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 128; i < 256; i++) {
	j = i - 128;
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[j]);
    }
}
